/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao;

import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.EsquemaCorrida;
import com.rjconsultores.ventaboletos.entidad.EsquemaOperacional;
import com.rjconsultores.ventaboletos.entidad.Marca;
import com.rjconsultores.ventaboletos.entidad.RolOperativo;
import com.rjconsultores.ventaboletos.entidad.Ruta;
import com.rjconsultores.ventaboletos.entidad.Tramo;

import java.util.Date;
import java.util.List;

/**
 *
 * @author Rafius
 */
public interface EsquemaCorridaDAO extends GenericDAO<EsquemaCorrida, Integer> {

    public List<EsquemaCorrida> buscarPorEsquemaOperacional(EsquemaOperacional eo);

    public List<EsquemaCorrida> buscar(Marca marca, RolOperativo rolOperativo,
            Ruta ruta, ClaseServicio claseServicio);

    public List<EsquemaCorrida> buscar(EsquemaCorrida ec);
    
    /**
     * Indica se el esquema corrida es hijo de un esquemCorrida.
     * 
     * @param esquemaCorrida
     * @return 
     */
    public boolean esHijoRebote(EsquemaCorrida esquemaCorrida);
    
    /**
     * Busca los esquema corrida que tiene esquema operacional en la fecha indicada
     * @param dataGeracao
     * @return
     */
    public List<EsquemaCorrida> buscaDentroVigencia(Date dataGeracao);

    public boolean buscarEsquemaCorridaExisteTramo(Tramo tramo);
    
    /**
     * Indica cul son los Id's de EsquemaCorrida que tienen la paradaId en su secuencia 
     * 
     * @param ruta
     * @param paradaId
     * @return - El Id de EsquemaCorrida
     */
    public List<Integer> existe(Ruta ruta , Integer paradaId);
}
