/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao;

import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.Ruta;
import com.rjconsultores.ventaboletos.entidad.Tramo;
import java.util.List;

/**
 *
 * @author Rafius
 */
public interface RutaDAO extends GenericDAO<Ruta, Integer> {

    public List<Ruta> buscarPorTramo(Tramo tramo);

    public List<Ruta> buscarPorRutaPorEmpresa(Ruta ruta, Empresa empresa);

    public List<Ruta> buscarPorClaseServicio(ClaseServicio claseServicio);

    public List<Ruta> buscar(String nomeRuta, ClaseServicio claseServicio,
            Boolean nomeObrigatorio);

    public List<Ruta> obtenerPorEmpresa(Empresa empresa);
    
    public List<Ruta> buscarTodosExceto(Integer... idRuta);

    /**
     * Regresa la origen de la ruta
     * @param ruta
     * @return
     */
	public Parada buscarOrigen(Ruta ruta);

	/**
     * Regresa el destino de la ruta
     * @param ruta
     * @return
     */
	public Parada buscarDestino(Ruta ruta);
	
}
