/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import com.rjconsultores.ventaboletos.dao.CorridaCtrlDAO;
import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.CorridaCtrl;
import com.rjconsultores.ventaboletos.entidad.Marca;
import com.rjconsultores.ventaboletos.entidad.Ruta;
import java.util.Date;
import java.util.List;
import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

/**
 *
 * @author Administrador
 */
@Repository("corridaCtrlDAO")
public class CorridaCtrlHibernateDAO extends GenericHibernateDAO<CorridaCtrl, Integer>
        implements CorridaCtrlDAO {

    @Autowired
    public CorridaCtrlHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    public CorridaCtrl buscar(Ruta ruta, ClaseServicio claseServicio, Marca marca,
            Date horario, boolean isPisoExtra) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.add(Restrictions.eq("marca", marca));
        c.add(Restrictions.eq("claseServicio", claseServicio));
        c.add(Restrictions.eq("ruta", ruta));
        c.add(Restrictions.eq("horario", horario));
        
        if (isPisoExtra) {
            //CorridaCtrl para Piso Extra
            c.add(Restrictions.eq("pisoExtra", true));
        } else {
            //num piso == null ou false
            c.add(Restrictions.or(Restrictions.not(Restrictions.eq("pisoExtra", true)), Restrictions.isNull("pisoExtra")));
        }

        List<CorridaCtrl> lsCorridaCtrl = c.list();

        if ((lsCorridaCtrl == null) || (lsCorridaCtrl.isEmpty())) {
            return null;
        } else {
            return lsCorridaCtrl.get(0);
        }
    }
}
