/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import com.rjconsultores.ventaboletos.dao.UsuarioDAO;
import com.rjconsultores.ventaboletos.entidad.Empleado;
import com.rjconsultores.ventaboletos.entidad.Usuario;
import java.util.List;
import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

/**
 *
 * @author rodrigo
 */
@Repository("usuarioDAO")
public class UsuarioHibernateDAO extends GenericHibernateDAO<Usuario, Integer>
        implements UsuarioDAO {

    @Autowired
    public UsuarioHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
    public List<Usuario> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));

        return c.list();
    }

    public List<Usuario> buscarPeloNome(String nome) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));

        c.add(Restrictions.eq("nombusuario", nome));
        c.addOrder(Order.asc("nombusuario"));

        return c.list();
    }

    public Usuario buscarPeloNomeSenha(String stUsuario, String senha) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("claveUsuario", stUsuario));
        c.add(Restrictions.eq("senha", senha));
        c.add(Restrictions.eq("activo", Boolean.TRUE));

        return (Usuario) c.uniqueResult();
    }

    public List<Usuario> buscarPorEmpleado(Empleado empleado) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));

        c.add(Restrictions.eq("empleado", empleado));

        return c.list();
    }

    public List<Usuario> buscarPelaCveUsuario(String cveUsuario) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));

        c.add(Restrictions.eq("claveUsuario", cveUsuario));

        return c.list();
    }
}
