package com.rjconsultores.ventaboletos.dao.sqlbuilder;


/**
 * Interface que indica quais so os SQL nativos da aplicao.
 * 
 * Cada mtodo representa um SQL nativo que deve ser implementado de acordo com a base de dados.
 * 
 * O padro para a clase  retornar o SQL nativo para o conjunto de parametros
 * 
 * 
 * @author gleimar
 *
 */
public interface SQLBuilder {

	public String getSQLGerarTarifaOficial(Integer codRuta, Integer usuarioId, Integer orgaoConcedenteId);
	
	public String getSQLAtualizarTarifaOficial(Integer rutaId, Integer usuarioId, Integer orgaoConcedenteId);
	
	public String getAtualizarTaxaEmbarquePorKmParada(Integer rutaId, Integer usuarioId, Integer orgaoConcedenteId);
	
	public String getSQLAtualizarTaxaEmbarquePorKmOrgao(Integer rutaId, Integer usuarioId, Integer orgaoConcedenteId);
	
	public String getSQLAtualizarTaxaEmbarquePorParadaFixo(Integer rutaId, Integer usuarioId, Integer orgaoConcedenteId);
	
	public String getSQLAtualizarSeguroPorKm(Integer rutaId, Integer usuarioId, Integer orgaoConcedenteId);
	
	public String getSQLAtualizarSeguroPorTarifa(Integer rutaId, Integer usuarioId, Integer orgaoConcedenteId);
	
	
}
