/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.SequenceGenerator;

/**
 *
 * @author Administrador
 */
@Entity
@SequenceGenerator(name = "CATEGORIA_DESCUENTO_SEQ", sequenceName = "CATEGORIA_DESCUENTO_SEQ", allocationSize = 1)
@Table(name = "CATEGORIA_DESCUENTO")
public class CategoriaDescuento implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "CATEGORIA_DESCUENTO_SEQ")
    @Column(name = "CATEGORIADESCUENTO_ID")
    private Integer categoriadescuentoId;
    @Column(name = "CANTAUTORIZADA")
    private Integer cantautorizada;
    @Column(name = "DESCUENTOPORC")
    private BigDecimal descuentoporc;
    @Column(name = "DESCUENTOIMPORTE")
    private BigDecimal descuentoimporte;
    @Column(name = "ACTIVO")
    private Boolean activo;
    @Basic(optional = false)
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
    @Column(name = "USUARIO_ID")
    private Integer usuarioId;
    @JoinColumn(name = "CATEGORIACTRL_ID", referencedColumnName = "CATEGORIACTRL_ID")
    @ManyToOne(cascade = CascadeType.ALL)
    private CategoriaCtrl categoriaCtrl;
    @JoinColumn(name = "CATEGORIA_ID", referencedColumnName = "CATEGORIA_ID")
    @ManyToOne
    private Categoria categoria;
    @OneToMany(mappedBy = "categoriaDescuento", cascade = CascadeType.ALL)
    private List<CategoriaPeriodo> categoriaPeriodoList;

    public CategoriaDescuento() {
    }

    public CategoriaDescuento(Integer categoriadescuentoId) {
        this.categoriadescuentoId = categoriadescuentoId;
    }

    public CategoriaDescuento(Integer categoriadescuentoId, Date fecmodif) {
        this.categoriadescuentoId = categoriadescuentoId;
        this.fecmodif = fecmodif;
    }

    public Integer getCategoriadescuentoId() {
        return categoriadescuentoId;
    }

    public void setCategoriadescuentoId(Integer categoriadescuentoId) {
        this.categoriadescuentoId = categoriadescuentoId;
    }

    public Integer getCantautorizada() {
        return cantautorizada;
    }

    public void setCantautorizada(Integer cantautorizada) {
        this.cantautorizada = cantautorizada;
    }

    public BigDecimal getDescuentoporc() {
        return descuentoporc;
    }

    public void setDescuentoporc(BigDecimal descuentoporc) {
        this.descuentoporc = descuentoporc;
    }

    public BigDecimal getDescuentoimporte() {
        return descuentoimporte;
    }

    public void setDescuentoimporte(BigDecimal descuentoimporte) {
        this.descuentoimporte = descuentoimporte;
    }

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public Integer getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(Integer usuarioId) {
        this.usuarioId = usuarioId;
    }

    public CategoriaCtrl getCategoriaCtrl() {
        return categoriaCtrl;
    }

    public void setCategoriaCtrl(CategoriaCtrl categoriaCtrl) {
        this.categoriaCtrl = categoriaCtrl;
    }

    public Categoria getCategoria() {
        return categoria;
    }

    public void setCategoria(Categoria categoria) {
        this.categoria = categoria;
    }

    public List<CategoriaPeriodo> getCategoriaPeriodoList() {
        List<CategoriaPeriodo> tmp = new ArrayList<CategoriaPeriodo>();
        if (categoriaPeriodoList != null) {
            for (CategoriaPeriodo cp : this.categoriaPeriodoList) {
                if (cp.getActivo()) {
                    tmp.add(cp);
                }
            }
        }

        return tmp;
    }

    public void setCategoriaPeriodoList(List<CategoriaPeriodo> categoriaPeriodoList) {
        this.categoriaPeriodoList = categoriaPeriodoList;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final CategoriaDescuento other = (CategoriaDescuento) obj;
        if (this.categoriaCtrl != other.categoriaCtrl && (this.categoriaCtrl == null || !this.categoriaCtrl.equals(other.categoriaCtrl))) {
            return false;
        }
        if (this.categoria != other.categoria && (this.categoria == null || !this.categoria.equals(other.categoria))) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 53 * hash + (this.categoriaCtrl != null ? this.categoriaCtrl.hashCode() : 0);
        hash = 53 * hash + (this.categoria != null ? this.categoria.hashCode() : 0);
        return hash;
    }

    @Override
    public String toString() {
        return "com.rjconsultores.ventaboletos.entidad.CategoriaDescuento[categoriadescuentoId=" + categoriadescuentoId + "]";
    }
}
