package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.OneToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

@Entity
@SequenceGenerator(name = "CONF_RESTRICAO_CANALVENTA_SEQ", sequenceName = "CONF_RESTRICAO_CANALVENTA_SEQ", allocationSize = 1)
@Table(name = "CONF_RESTRICAO_CANALVENTA")
public class ConfRestricaoCanalVenta implements Serializable {

	private static final long serialVersionUID = 1L;
	@Id
	@Basic(optional = false)
	@GeneratedValue(strategy = GenerationType.AUTO, generator = "CONF_RESTRICAO_CANALVENTA_SEQ")
	@Column(name = "CONFRESTRICAOCANALVENTA_ID")
	private Integer confRestricaoCanalVentaId;
	@Column(name = "DESCCONFRESTRICAOCANALVENTA")
	private String descConfRestricaoCanalVenta;
	@OneToOne
	@JoinColumn(name = "TIPOPTOVTA_ID")
	private TipoPuntoVenta tipoPuntoVenta;
	@OneToOne
	@JoinColumn(name = "ORIGEN_ID")
	private Parada origem;
	@OneToOne
	@JoinColumn(name = "DESTINO_ID")
	private Parada destino;
	@Column(name = "TEMPOPERMITIR")
	private Date tempoPermitir;
	@Column(name = "CORRIDA_ID")
	private Integer corridaId;
	@Column(name = "FECCORRIDA")
	private Date fecCorrida;
	@Column(name = "SEGUNDA")
	private Boolean segunda;
	@Column(name = "TERCA")
	private Boolean terca;
	@Column(name = "QUARTA")
	private Boolean quarta;
	@Column(name = "QUINTA")
	private Boolean quinta;
	@Column(name = "SEXTA")
	private Boolean sexta;
	@Column(name = "SABADO")
	private Boolean sabado;
	@Column(name = "DOMINGO")
	private Boolean domingo;
	@Column(name = "ACTIVO")
	private Boolean activo;
	@Column(name = "FECMODIF")
	@Temporal(TemporalType.TIMESTAMP)
	private Date fecmodif;
	@Column(name = "USUARIO_ID")
	private Integer usuarioId;

	public Integer getConfRestricaoCanalVentaId() {
		return confRestricaoCanalVentaId;
	}

	public void setConfRestricaoCanalVentaId(Integer confRestricaoCanalVentaId) {
		this.confRestricaoCanalVentaId = confRestricaoCanalVentaId;
	}

	public String getDescConfRestricaoCanalVenta() {
		return descConfRestricaoCanalVenta;
	}

	public void setDescConfRestricaoCanalVenta(String descConfRestricaoCanalVenta) {
		this.descConfRestricaoCanalVenta = descConfRestricaoCanalVenta;
	}

	public TipoPuntoVenta getTipoPuntoVenta() {
		return tipoPuntoVenta;
	}

	public void setTipoPuntoVenta(TipoPuntoVenta tipoPuntoVenta) {
		this.tipoPuntoVenta = tipoPuntoVenta;
	}

	public Parada getOrigem() {
		return origem;
	}

	public void setOrigem(Parada origem) {
		this.origem = origem;
	}

	public Parada getDestino() {
		return destino;
	}

	public void setDestino(Parada destino) {
		this.destino = destino;
	}

	public Date getTempoPermitir() {
		return tempoPermitir;
	}

	public void setTempoPermitir(Date tempoPermitir) {
		this.tempoPermitir = tempoPermitir;
	}

	public Integer getCorridaId() {
		return corridaId;
	}

	public void setCorridaId(Integer corridaId) {
		this.corridaId = corridaId;
	}

	public Date getFecCorrida() {
		return fecCorrida;
	}

	public void setFecCorrida(Date fecCorrida) {
		this.fecCorrida = fecCorrida;
	}

	public Boolean getSegunda() {
		return segunda;
	}

	public void setSegunda(Boolean segunda) {
		this.segunda = segunda;
	}

	public Boolean getTerca() {
		return terca;
	}

	public void setTerca(Boolean terca) {
		this.terca = terca;
	}

	public Boolean getQuarta() {
		return quarta;
	}

	public void setQuarta(Boolean quarta) {
		this.quarta = quarta;
	}

	public Boolean getQuinta() {
		return quinta;
	}

	public void setQuinta(Boolean quinta) {
		this.quinta = quinta;
	}

	public Boolean getSexta() {
		return sexta;
	}

	public void setSexta(Boolean sexta) {
		this.sexta = sexta;
	}

	public Boolean getSabado() {
		return sabado;
	}

	public void setSabado(Boolean sabado) {
		this.sabado = sabado;
	}

	public Boolean getDomingo() {
		return domingo;
	}

	public void setDomingo(Boolean domingo) {
		this.domingo = domingo;
	}

	public Boolean getActivo() {
		return activo;
	}

	public void setActivo(Boolean activo) {
		this.activo = activo;
	}

	public Date getFecmodif() {
		return fecmodif;
	}

	public void setFecmodif(Date fecmodif) {
		this.fecmodif = fecmodif;
	}

	public Integer getUsuarioId() {
		return usuarioId;
	}

	public void setUsuarioId(Integer usuarioId) {
		this.usuarioId = usuarioId;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((confRestricaoCanalVentaId == null) ? 0 : confRestricaoCanalVentaId.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ConfRestricaoCanalVenta other = (ConfRestricaoCanalVenta) obj;
		if (confRestricaoCanalVentaId == null) {
			if (other.confRestricaoCanalVentaId != null)
				return false;
		} else if (!confRestricaoCanalVentaId.equals(other.confRestricaoCanalVentaId))
			return false;
		return true;
	}
}
