/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 * 
 * @author Rafius
 */
@Entity
@SequenceGenerator(name = "EMPRESA_SEQ", sequenceName = "EMPRESA_SEQ", allocationSize = 1)
@Table(name = "EMPRESA")
public class Empresa implements Serializable {

	private static final long serialVersionUID = 1L;
	@Id
	@Basic(optional = false)
	@GeneratedValue(strategy = GenerationType.AUTO, generator = "EMPRESA_SEQ")
	@Column(name = "EMPRESA_ID")
	private Integer empresaId;
	@Column(name = "NOMBEMPRESA")
	private String nombempresa;
	@Column(name = "ACTIVO")
	private Boolean activo;
	@Basic(optional = false)
	@Column(name = "FECMODIF")
	@Temporal(TemporalType.TIMESTAMP)
	private Date fecmodif;
	@Column(name = "USUARIO_ID")
	private Integer usuarioId;
	@OneToMany(mappedBy = "empresa")
	private List<PuntoVenta> puntoVentaList;
	@Column(name = "INDEXTERNA")
	private Boolean indExterna;
	@Column(name = "INDTIPO")
	private Short indTipo;
	@Column(name = "INDPAGOCONDUCTOR")
	private Boolean pagoConductor;
	@OneToMany(mappedBy = "empresa")
	private List<Corrida> corridaList;
	@OneToMany(mappedBy = "empresa1")
	private List<Corrida> corridaList1;
	@Column(name = "EQUIVALENCIAELEKTRA_ID")
	private String equivalenciaElektraId;
	@Column(name = "EQUIVALENCIA_ID")
	private String equivalenciaId;
	@Column(name = "RFC")
	private String rfc;
	@Column(name = "CNPJ")
	private String cnpj;
	@Column(name = "LOGRADOURO")
	private String logradouro;
	@Column(name = "NUMERO")
	private String numero;
	@Column(name = "COMPLEMENTO")
	private String complemento;
	@Column(name = "CEP")
	private String cep;
	@Column(name = "BAIRRO")
	private String bairro;
	@OneToOne(cascade = CascadeType.MERGE)
	@JoinColumn(name = "CIUDAD_ID")
	private Ciudad cidade;

	public Empresa() {
	}

	public Empresa(Integer empresaId) {
		this.empresaId = empresaId;
	}

	public Empresa(Integer empresaId, Date fecmodif) {
		this.empresaId = empresaId;
		this.fecmodif = fecmodif;
	}

	public Integer getEmpresaId() {
		return empresaId;
	}

	public void setEmpresaId(Integer empresaId) {
		this.empresaId = empresaId;
	}

	public String getNombempresa() {
		return nombempresa;
	}

	public void setNombempresa(String nombempresa) {
		this.nombempresa = nombempresa;
	}

	public Boolean getActivo() {
		return activo;
	}

	public void setActivo(Boolean activo) {
		this.activo = activo;
	}

	public Date getFecmodif() {
		return fecmodif;
	}

	public void setFecmodif(Date fecmodif) {
		this.fecmodif = fecmodif;
	}

	public Integer getUsuarioId() {
		return usuarioId;
	}

	public void setUsuarioId(Integer usuarioId) {
		this.usuarioId = usuarioId;
	}

	public List<PuntoVenta> getPuntoVentaList() {
		return puntoVentaList;
	}

	public void setPuntoVentaList(List<PuntoVenta> puntoVentaList) {
		this.puntoVentaList = puntoVentaList;
	}

	public Boolean getIndExterna() {
		return indExterna;
	}

	public void setIndExterna(Boolean indExterna) {
		this.indExterna = indExterna;
	}

	public Short getIndTipo() {
		return indTipo;
	}

	public void setIndTipo(Short indTipo) {
		this.indTipo = indTipo;
	}

	public Boolean getPagoConductor() {
		return pagoConductor;
	}

	public void setPagoConductor(Boolean pagoConductor) {
		this.pagoConductor = pagoConductor;
	}

	public String getEquivalenciaElektraId() {
		return equivalenciaElektraId;
	}

	public void setEquivalenciaElektraId(String equivalenciaElektraId) {
		this.equivalenciaElektraId = equivalenciaElektraId;
	}

	public String getEquivalenciaId() {
		return equivalenciaId;
	}

	public void setEquivalenciaId(String equivalenciaId) {
		this.equivalenciaId = equivalenciaId;
	}

	public String getRfc() {
		return rfc;
	}

	public void setRfc(String rfc) {
		this.rfc = rfc;
	}

	public String getCnpj() {
		return cnpj;
	}

	public void setCnpj(String cnpj) {
		this.cnpj = cnpj;
	}

	public String getLogradouro() {
		return logradouro;
	}

	public void setLogradouro(String logradouro) {
		this.logradouro = logradouro;
	}

	public String getNumero() {
		return numero;
	}

	public void setNumero(String numero) {
		this.numero = numero;
	}

	public String getComplemento() {
		return complemento;
	}

	public void setComplemento(String complemento) {
		this.complemento = complemento;
	}

	public String getCep() {
		return cep;
	}

	public void setCep(String cep) {
		this.cep = cep;
	}

	public String getBairro() {
		return bairro;
	}

	public void setBairro(String bairro) {
		this.bairro = bairro;
	}

	public Ciudad getCidade() {
		return cidade;
	}

	public void setCidade(Ciudad cidade) {
		this.cidade = cidade;
	}

	@Override
	public int hashCode() {
		int hash = 0;
		hash += (empresaId != null ? empresaId.hashCode() : 0);
		return hash;
	}

	@Override
	public boolean equals(Object object) {
		if (!(object instanceof Empresa)) {
			return false;
		}
		Empresa other = (Empresa) object;
		if ((this.empresaId == null && other.empresaId != null) || (this.empresaId != null && !this.empresaId.equals(other.empresaId))) {
			return false;
		}
		return true;
	}

	@Override
	public String toString() {
		return this.getNombempresa();
	}

	public List<Corrida> getCorridaList() {
		return corridaList;
	}

	public void setCorridaList(List<Corrida> corridaList) {
		this.corridaList = corridaList;
	}

	public List<Corrida> getCorridaList1() {
		return corridaList1;
	}

	public void setCorridaList1(List<Corrida> corridaList1) {
		this.corridaList1 = corridaList1;
	}
}
