package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

@Entity
@SequenceGenerator(name = "ORGAO_CONCEDENTE_SEQ", sequenceName = "ORGAO_CONCEDENTE_SEQ", allocationSize = 1)
@Table(name = "ORGAO_CONCEDENTE")
public class OrgaoConcedente implements Serializable {

	private static final long serialVersionUID = 1L;
	@Id
	@Basic(optional = false)
	@GeneratedValue(strategy = GenerationType.AUTO, generator = "ORGAO_CONCEDENTE_SEQ")
	@Column(name = "ORGAOCONCEDENTE_ID")
	private Integer orgaoConcedenteId;
	@Column(name = "DESCORGAO")
	private String descOrgao;
	@Column(name = "INDDEFAULTSEGURO")
	private Boolean indDefaultSeguro;
	@Column(name = "INDSUBSEGURO")
	private Boolean indSubSeguro;
	@Column(name = "ACTIVO")
	private Boolean activo;
	@Column(name = "FECMODIF")
	@Temporal(TemporalType.TIMESTAMP)
	private Date fecmodif;
	@Column(name = "USUARIO_ID")
	private Integer usuarioId;

	public Integer getOrgaoConcedenteId() {
		return orgaoConcedenteId;
	}

	public void setOrgaoConcedenteId(Integer orgaoConcedenteId) {
		this.orgaoConcedenteId = orgaoConcedenteId;
	}

	public String getDescOrgao() {
		return descOrgao;
	}

	public void setDescOrgao(String descOrgao) {
		this.descOrgao = descOrgao;
	}

	public Boolean getIndSubSeguro() {
		return indSubSeguro;
	}

	public void setIndSubSeguro(Boolean indSubSeguro) {
		this.indSubSeguro = indSubSeguro;
	}

	public Boolean getIndDefaultSeguro() {
		return indDefaultSeguro;
	}

	public void setIndDefaultSeguro(Boolean indDefaultSeguro) {
		this.indDefaultSeguro = indDefaultSeguro;
	}

	public Boolean getActivo() {
		return activo;
	}

	public void setActivo(Boolean activo) {
		this.activo = activo;
	}

	public Date getFecmodif() {
		return fecmodif;
	}

	public void setFecmodif(Date fecmodif) {
		this.fecmodif = fecmodif;
	}

	public Integer getUsuarioId() {
		return usuarioId;
	}

	public void setUsuarioId(Integer usuarioId) {
		this.usuarioId = usuarioId;
	}

	@Override
	public String toString() {
		return descOrgao;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((orgaoConcedenteId == null) ? 0 : orgaoConcedenteId.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		OrgaoConcedente other = (OrgaoConcedente) obj;
		if (orgaoConcedenteId == null) {
			if (other.orgaoConcedenteId != null)
				return false;
		} else if (!orgaoConcedenteId.equals(other.orgaoConcedenteId))
			return false;
		return true;
	}
}
