/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 *
 * @author Rafius
 */
@Entity
@SequenceGenerator(name = "PERFIL_SEQ", sequenceName = "PERFIL_SEQ", allocationSize = 1)
@Table(name = "PERFIL")
public class Perfil implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "PERFIL_SEQ")
    @Column(name = "PERFIL_ID")
    private Integer perfilId;
    @Column(name = "DESCPERFIL")
    private String descperfil;
    @Column(name = "ACTIVO")
    private Boolean activo;
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
    @Column(name = "USUARIO_ID")
    private Integer usuarioId;
    @OneToMany(mappedBy = "perfil")
    private List<UsuarioPerfil> usuarioPerfilList;
    @OneToMany(mappedBy = "perfil", cascade = CascadeType.ALL)
    private List<PerfilFuncion> perfilFuncionList;

    public Perfil() {
    }

    public Perfil(Integer perfilId) {
        this.perfilId = perfilId;
    }

    public Integer getPerfilId() {
        return perfilId;
    }

    public void setPerfilId(Integer perfilId) {
        this.perfilId = perfilId;
    }

    public String getDescperfil() {
        return descperfil;
    }

    public void setDescperfil(String descperfil) {
        this.descperfil = descperfil;
    }

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public Integer getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(Integer usuarioId) {
        this.usuarioId = usuarioId;
    }

    public List<UsuarioPerfil> getUsuarioPerfilList() {
        List<UsuarioPerfil> tmp = new ArrayList<UsuarioPerfil>();
        if (usuarioPerfilList != null) {
            for (UsuarioPerfil cp : this.usuarioPerfilList) {
                if (cp.getActivo()) {
                    tmp.add(cp);
                }
            }
        }

        return tmp;
    }

    public void setUsuarioPerfilList(List<UsuarioPerfil> usuarioPerfilList) {
        this.usuarioPerfilList = usuarioPerfilList;
    }

    public List<PerfilFuncion> getPerfilFuncionList() {
        List<PerfilFuncion> tmp = new ArrayList<PerfilFuncion>();
        if (perfilFuncionList != null) {
            for (PerfilFuncion cp : this.perfilFuncionList) {
                if (cp.getActivo()) {
                    tmp.add(cp);
                }
            }
        }

        return tmp;
    }

    public void setPerfilFuncionList(List<PerfilFuncion> perfilFuncionList) {
        this.perfilFuncionList = perfilFuncionList;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (perfilId != null ? perfilId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Perfil)) {
            return false;
        }
        Perfil other = (Perfil) object;
        if ((this.perfilId == null && other.perfilId != null) || (this.perfilId != null && !this.perfilId.equals(other.perfilId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return getDescperfil();
    }
}
