/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 *
 * @author Rafius
 */
@Entity
@SequenceGenerator(name = "PRICING_ASIENTO_SEQ", sequenceName = "PRICING_ASIENTO_SEQ", allocationSize = 1)
@Table(name = "PRICING_ASIENTO")
public class PricingAsiento implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "PRICING_ASIENTO_SEQ")
    @Column(name = "PRICINGASIENTO_ID")
    private Integer pricingasientoId;
    @Column(name = "NUMEASIENTO")
    private String numeasiento;
    @Column(name = "NOMBIMAGEN")
    private String nombImagen;
    @Column(name = "PORCENTAJE")
    private BigDecimal porcentaje;
    @Column(name = "ACTIVO")
    private Boolean activo;
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
    @Column(name = "USUARIO_ID")
    private Integer usuarioId;
    @JoinColumn(name = "PRICING_ID", referencedColumnName = "PRICING_ID")
    @ManyToOne
    private Pricing pricing;

    public PricingAsiento() {
    }

    public PricingAsiento(Integer pricingasientoId) {
        this.pricingasientoId = pricingasientoId;
    }

    public Integer getPricingasientoId() {
        return pricingasientoId;
    }

    public void setPricingasientoId(Integer pricingasientoId) {
        this.pricingasientoId = pricingasientoId;
    }

    public String getNumeasiento() {
        return numeasiento;
    }

    public void setNumeasiento(String numeasiento) {
        this.numeasiento = numeasiento;
    }

    public BigDecimal getPorcentaje() {
        return porcentaje;
    }

    public void setPorcentaje(BigDecimal porcentaje) {
        this.porcentaje = porcentaje;
    }

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public Integer getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(Integer usuarioId) {
        this.usuarioId = usuarioId;
    }

    public Pricing getPricing() {
        return pricing;
    }

    public void setPricing(Pricing pricing) {
        this.pricing = pricing;
    }

    public String getNombImagen() {
        return nombImagen;
    }

    public void setNombImagen(String nombImagen) {
        this.nombImagen = nombImagen;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (pricingasientoId != null ? pricingasientoId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof PricingAsiento)) {
            return false;
        }
        PricingAsiento other = (PricingAsiento) object;
        if ((this.pricingasientoId == null && other.pricingasientoId != null) || (this.pricingasientoId != null && !this.pricingasientoId.equals(other.pricingasientoId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "entidad.test.PricingAsiento[pricingasientoId=" + pricingasientoId + "]";
    }
}
