/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.CategoriaDescuentoDAO;
import com.rjconsultores.ventaboletos.entidad.CategoriaDescuento;
import com.rjconsultores.ventaboletos.service.CategoriaDescuentoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Administrador
 */
@Service("categoriaDescuentoService")
public class CategoriaDescuentoServiceImpl implements CategoriaDescuentoService {

    @Autowired
    private CategoriaDescuentoDAO categoriaDescuentoDAO;

    public List<CategoriaDescuento> obtenerTodos() {
        return categoriaDescuentoDAO.obtenerTodos();
    }

    public CategoriaDescuento obtenerID(Integer id) {
        return categoriaDescuentoDAO.obtenerID(id);
    }

    @Transactional
    public CategoriaDescuento suscribir(CategoriaDescuento entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return categoriaDescuentoDAO.suscribir(entidad);
    }

    @Transactional
    public CategoriaDescuento actualizacion(CategoriaDescuento entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return categoriaDescuentoDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(CategoriaDescuento entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        categoriaDescuentoDAO.actualizacion(entidad);
    }
}
