/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.ConvenioDAO;
import com.rjconsultores.ventaboletos.entidad.Convenio;
import com.rjconsultores.ventaboletos.entidad.ConvenioDet;
import com.rjconsultores.ventaboletos.service.ConvenioService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Administrador
 */
@Service("convenioService")
public class ConvenioServiceImpl implements ConvenioService {

    @Autowired
    private ConvenioDAO convenioDAO;

    public List<Convenio> obtenerTodos() {
        return convenioDAO.obtenerTodos();
    }

    public Convenio obtenerID(Integer id) {
        return convenioDAO.obtenerID(id);
    }

    @Transactional
    public Convenio suscribir(Convenio entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return convenioDAO.suscribir(entidad);
    }

    @Transactional
    public Convenio actualizacion(Convenio entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return convenioDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(Convenio entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        for (ConvenioDet cd : entidad.getConvenioDetList()) {
            cd.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            cd.setFecmodif(Calendar.getInstance().getTime());
            cd.setActivo(Boolean.FALSE);
        }
        
        convenioDAO.actualizacion(entidad);
    }

    public List<Convenio> buscar(String descconvenio, String cveconvenio) {
        return convenioDAO.buscar(descconvenio, cveconvenio);
    }
}
