/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.FormaPagoDAO;
import com.rjconsultores.ventaboletos.entidad.FormaPago;
import com.rjconsultores.ventaboletos.service.FormaPagoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Administrador
 */
@Service("formaPagoService")
public class FormaPagoServiceImpl implements FormaPagoService {

    private Integer[] formasPagoEspeciales = {4, 5, 6, 9, 10, 11, 96, 97, 98, 99};
    
    @Autowired
    private FormaPagoDAO formaPagoDAO;

    public List<FormaPago> obtenerTodos() {
        return formaPagoDAO.obtenerTodos();
    }

    public FormaPago obtenerID(Short id) {
        return formaPagoDAO.obtenerID(id);
    }

    @Transactional
    public FormaPago suscribir(FormaPago entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return formaPagoDAO.suscribir(entidad);
    }

    @Transactional
    public FormaPago actualizacion(FormaPago entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return formaPagoDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(FormaPago entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        formaPagoDAO.actualizacion(entidad);
    }

    public List<FormaPago> buscarPorDescricao(String descpago) {
        return formaPagoDAO.buscarPorDescricao(descpago);
    }
    
    public List<FormaPago> buscarFormasPagoExceptoEspeciales() {
        return formaPagoDAO.buscarTodosExceto(formasPagoEspeciales);
    }
}
