/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.PricingMarcaDAO;
import com.rjconsultores.ventaboletos.entidad.Marca;
import com.rjconsultores.ventaboletos.entidad.Pricing;
import com.rjconsultores.ventaboletos.entidad.PricingMarca;
import com.rjconsultores.ventaboletos.service.PricingMarcaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Rafius
 */
@Service("pricingMarcaService")
public class PricingMarcaServiceImpl implements PricingMarcaService {

    @Autowired
    private PricingMarcaDAO pricingMarcaDAO;

    public List<PricingMarca> obtenerTodos() {
        return pricingMarcaDAO.obtenerTodos();
    }

    public PricingMarca obtenerID(Integer id) {
        return pricingMarcaDAO.obtenerID(id);
    }

    @Transactional
    public PricingMarca suscribir(PricingMarca entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return pricingMarcaDAO.suscribir(entidad);
    }

    @Transactional
    public PricingMarca actualizacion(PricingMarca entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return pricingMarcaDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(PricingMarca entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        pricingMarcaDAO.actualizacion(entidad);
    }

    public Boolean obtenerPricingMarca(Pricing pricing, Marca marca) {
        return pricingMarcaDAO.obtenerPricingMarca(pricing,marca);
    }
}
