package com.rjconsultores.ventaboletos.vo.esquemaoperacional;

import java.math.BigDecimal;

import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.Via;
import com.rjconsultores.ventaboletos.utilerias.DateUtil.Hora;

public class SecuenciaRutaTramoVO {

	private Parada origen;
	private Parada destino;
	private Via via;
	private Integer secuencia;
	private BigDecimal kmReal;
	private Hora tiempoRecorrido;
	private Integer tramoId;
	private Integer tramoServicioId;

	public SecuenciaRutaTramoVO(Parada origen, Parada destino, Via via, Integer secuencia, BigDecimal kmReal,
			Hora tiempoRecorrido) {
		super();
		this.origen = origen;
		this.destino = destino;
		this.via = via;
		this.secuencia = secuencia;
		this.kmReal = kmReal;
		this.setTiempoRecorrido(tiempoRecorrido);
	}

	public SecuenciaRutaTramoVO(Parada origen, Parada destino, Integer secuencia, Via via) {
		super();
		this.origen = origen;
		this.destino = destino;
		this.secuencia = secuencia;
		this.via = via;
		this.setTiempoRecorrido(null);
	}

	public SecuenciaRutaTramoVO(Parada origen, Parada destino, Via via, Integer secuencia, BigDecimal kmReal,
			Hora tiempoRecorrido, Integer tramoId, Integer tramoServicioId) {
		super();
		this.origen = origen;
		this.destino = destino;
		this.via = via;
		this.secuencia = secuencia;
		this.kmReal = kmReal;
		this.setTiempoRecorrido(tiempoRecorrido);
		this.tramoId = tramoId;
		this.tramoServicioId = tramoId;
	}

	public Parada getOrigen() {
		return origen;
	}

	public void setOrigen(Parada origen) {
		this.origen = origen;
	}

	public Parada getDestino() {
		return destino;
	}

	public Hora getTiempoRecorrido() {
		return tiempoRecorrido;
	}

	public void setTiempoRecorrido(Hora tiempoRecorrido) {
		if (tiempoRecorrido == null) {
			tiempoRecorrido = new Hora();
		}
		this.tiempoRecorrido = tiempoRecorrido;
	}

	public void setDestino(Parada destino) {
		this.destino = destino;
	}

	public Via getVia() {
		return via;
	}

	public void setVia(Via via) {
		this.via = via;
	}

	public Integer getSecuencia() {
		return secuencia;
	}

	public void setSecuencia(Integer secuencia) {
		this.secuencia = secuencia;
	}

	public BigDecimal getKmReal() {
		return kmReal;
	}

	public void setKmReal(BigDecimal kmReal) {
		this.kmReal = kmReal;
	}

	public Integer getTramoId() {
		return tramoId;
	}

	public void setTramoId(Integer tramoId) {
		this.tramoId = tramoId;
	}

	public Integer getTramoServicioId() {
		return tramoServicioId;
	}

	public void setTramoServicioId(Integer tramoServicioId) {
		this.tramoServicioId = tramoServicioId;
	}

	@Override
	public String toString() {
		Hora hora = getTiempoRecorrido();

		return secuencia + ";" + origen + ";" + destino + ";" + via + ";" + kmReal + ";"
				+ ((hora != null) ? hora.getHora() : "-") + ";" + ((hora != null) ? hora.getMinuto() : "-");
	}
}
